--[[

	Fucntions added by Ascendant on:  08.18.05
	Adds slash command handler to remove latency bar, change 'out of range' indicator color, and hide class bar

]]

local bVarsLoaded = false;
local bModLoaded = false;

local function Asc_BibMod_CmdCapture(msg)
	-- used to separate the command from the parameter in the input string
	
	local params = msg;
	local command = params;
	local index = strfind(command, " ");
	
	if ( index ) then	
		command = strsub(command, 1, index-1);
		params = strsub(params, index+1, -1);		
	else	
		params = "";		
	end	
	return command, params;

end

function Asc_BibMod_OnLoad()
	
	this:RegisterEvent("VARIABLES_LAODED");
	this:RegisterEvent("ADDONS_LOADED");
	
	-- Registers slash commands to be used to modify settings ingame (added by Ascendant)	
	
	SLASH_BIBMOD1 = "/bibmod";
	SLASH_BIBMOD2 = "/ixbib";
	SLASH_BIBMOD3 = "/ix";
	SlashCmdList["BIBMOD"] = function(msg)
		Asc_BibSlashCmdHndlr(msg);
		
	end

end

function Asc_BibMod_OnEvent()

	if ((event == "VARIABLES_LOADED") or (event == "ADDONS_LOADED")) then
		bVarsLoaded = true;		
		if (not bModLoaded) then 				 
			if ((UnitName("player") ~= nil) and (UnitName("player") ~= UNKNOWNOBJECT) and (UnitName("player") ~= "unknown")) then				
				Asc_BibMod_Init();
			end			
		end	
		if (event == "VARIABLES_LOADED") then
			local bibtoolbars_loaded = IsAddOnLoaded("Insomniax_BibToolbars");
			if (bibtoolbars_loaded == 1) then
				-- DEFAULT_CHAT_FRAME:AddMessage("I am in the ADDONS_LOADED event handler");
				-- LedMirage 1.30.2006 10 to 7
				for i=1, 7, 1 do
					if (Asc_BibMod_Config.ShowBibBar[i]) then
						local actionbarname = getglobal("BibActionBar"..i):GetName();
						local actionbar = getglobal("BibActionBar"..i);
						--getglobal("BibActionBar"..i):Show();
						actionbar:Show();
						--test1 = getglobal(actionbarname);
						--DEFAULT_CHAT_FRAME:AddMessage(tostring(test1));
						LayoutBibActionBar(actionbarname);
						--RedrawBibActionBar(getglobal("BibActionBar"..i));
						--RedrawAllBibActionBars();
					else
						getglobal("BibActionBar"..i):Hide();
					end
				end
			end
			end
		return;
	end
	
	if ((event == "PLAYER_ENTERING_WORLD") or (event == "UNIT_NAME_UPDATE")) then
		bVarsLoaded = true;		
		if (not bModLoaded) then 				 
			if ((UnitName("player") ~= nil) and (UnitName("player") ~= UNKNOWNOBJECT) and (UnitName("player") ~= "unknown")) then				
				Asc_BibMod_Init();
			end				
		end		
		return;
	end
	
end

function Asc_BibMod_Init()

	if (bModLoaded == true) then
		return;
	end				
	if (bVarsLoaded == false) then 
		return;
	end			
	
	if (not Asc_BibMod_Config) then
		Asc_BibMod_Config = {};
		Asc_BibMod_InitVars();
	else
		Asc_BibMod_VerifyVars();
	end
	
	--DEFAULT_CHAT_FRAME:AddMessage("Ascendant's BibMod tweaks loaded.",225/255, 0, 175/255);
	if(ChatFrame2) then
		InsomniaxBibToolbarsVersionOnChat(); -- Defined in \Insomniax_BibToolbars\BibActionButtons.lua
		ChatFrame2:AddMessage("Ascendant's Insomniax BibCore v"..INSOMNIAX_BIBCORE_VERSION.." loaded.",225/255, 0, 175/255);
	else
		if ( DEFAULT_CHAT_FRAME ) then
			InsomniaxBibToolbarsVersionOnChat(); -- Defined in \Insomniax_BibToolbars\BibActionButtons.lua
			DEFAULT_CHAT_FRAME:AddMessage("Ascendant's Insomniax BibCore v"..INSOMNIAX_BIBCORE_VERSION.." loaded.",225/255, 0, 175/255);
		end
	end
	
	bModLoaded = true;

end

function Asc_BibMod_InitVars()

	if (Asc_BibMod_Config.BibClassBarToggle == nil) then
		Asc_BibMod_Config.BibClassBarToggle = true;
		ShapeshiftBarFrame:Show();
	end
	if (Asc_BibMod_Config.BibRangeColor == nil) then
		Asc_BibMod_Config.BibRangeColor = "default";
	end
	if (not Asc_BibMod_Config.ShowBibBar) then
		Asc_BibMod_Config.ShowBibBar = {};
		for i=1, BIB_ACTION_BAR_COUNT, 1 do
			if (not Asc_BibMod_Config.ShowBibBar[i]) then
				Asc_BibMod_Config.ShowBibBar[i] = true;
			end
		end
	end
	if(ChatFrame2) then
		ChatFrame2:AddMessage(UnitName("player").."'s settings for Ascendant's Insomniax BibCore tweaks registered.",225/255, 0, 175/255);
	else
		if ( DEFAULT_CHAT_FRAME ) then 	
			DEFAULT_CHAT_FRAME:AddMessage(UnitName("player").."'s settings for Ascendant's Insomniax BibCore tweaks registered.",225/255, 0, 175/255);
		end
	end
end

function Asc_BibMod_VerifyVars()

	local bVarsUpdated = nil;


	if (Asc_BibMod_Config.BibClassBarToggle == nil) then
		Asc_BibMod_Config.BibClassBarToggle = true;
		ShapeshiftBarFrame:Show();
		bVarsUpdated = true;
	end
	if (Asc_BibMod_Config.BibRangeColor == nil) then
		Asc_BibMod_Config.BibRangeColor = "default";
		bVarsUpdated = true;
	end

	if (not Asc_BibMod_Config.ShowBibBar) then
		Asc_BibMod_Config.ShowBibBar = {};
		for i=1, BIB_ACTION_BAR_COUNT, 1 do
			if (not Asc_BibMod_Config.ShowBibBar[i]) then
				Asc_BibMod_Config.ShowBibBar[i] = true;
			end
		end
		bVarsUpdated = true;
	end
	
	if (bVarUpdated) then
		DEFAULT_CHAT_FRAME:AddMessge("Variables have been updated for Ascendant's BibMod tweaks.",225/255, 0, 175/255);
	end

end

function Asc_BibSlashCmdHndlr(msg)
	-- controls how slash commands act
	
	msg = string.lower(msg);
	
	if ((not msg) or (msg == "") or (strlen(msg) <= 0) or (strfind(msg, "help"))) then 
		
		Asc_BibModHelp();
		
	elseif (strfind(msg, "classbar")) then
		
		if (ShapeshiftBarFrame:IsVisible()) then
			ShapeshiftBarFrame:Hide();
			Asc_BibMod_Config.BibClassBarToggle = false;
			DEFAULT_CHAT_FRAME:AddMessage("The class bar is now being hidden.",225/255, 0, 175/255);
		else
			ShapeshiftBarFrame:Show();
			Asc_BibMod_Config.BibClassBarToggle = true;
			DEFAULT_CHAT_FRAME:AddMessage("The class bar is now being displayed.",225/255, 0, 175/255);
		end
		
	elseif (strfind(msg, "color")) then
		local command, param = Asc_BibMod_CmdCapture(msg);
		
		if (strfind(param, "default")) then
			Asc_BibMod_Config.BibRangeColor = "default";
			DEFAULT_CHAT_FRAME:AddMessage("Target range color indicator has been set to default.",20/255, 106/255, 124/255);
		elseif (strfind(param, "red")) then
			Asc_BibMod_Config.BibRangeColor = "red";
			DEFAULT_CHAT_FRAME:AddMessage("Target range color indicator has been set to red.",255/255, 0, 0);
		elseif (strfind(param, "green")) then
			Asc_BibMod_Config.BibRangeColor = "green";
			DEFAULT_CHAT_FRAME:AddMessage("Target range color indicator has been set to green.",0, 255/255,0);
		elseif (strfind(param, "blue")) then
			Asc_BibMod_Config.BibRangeColor = "blue";
			DEFAULT_CHAT_FRAME:AddMessage("Target range color indicator has been set to blue.",0, 0, 255/255);
		elseif (strfind(param, "black")) then
			Asc_BibMod_Config.BibRangeColor = "black";
			DEFAULT_CHAT_FRAME:AddMessage("Target range color indicator has been set to black.",10/255, 10/255, 10/255);			
		else
			Asc_BibMod_Config.BibRangeColor = "default";
			DEFAULT_CHAT_FRAME:AddMessage("Invalid color option.  Target range color indicator has been set to default.",100/255, 75/255, 200/255);
		end

	elseif (strfind(msg, "hidebar")) then
		local command, param = Asc_BibMod_CmdCapture(msg);
		
		param = tonumber(param);
		
		if ((param > 0) and (param <= BIB_ACTION_BAR_COUNT)) then
			if (Asc_BibMod_Config.ShowBibBar[param]) then
				Asc_BibMod_Config.ShowBibBar[param] = false;
				DEFAULT_CHAT_FRAME:AddMessage("Insomniax BibActionBar "..param.." has been hidden.",225/255, 0, 175/255);
				if (param == 1) then
					local actionbarname = getglobal("BibActionBar"..param):GetName();
					SetHashedSaveValue("ActionBarOrientations", actionbarname, math.mod(GetHashedSaveValue("ActionBarOrientations", actionbarname) + 1, 13));
					BibActionBar1:Hide();
				elseif (param == 2) then
					BibActionBar2:Hide();
				elseif (param == 3) then
					BibActionBar3:Hide();
				elseif (param == 4) then
					BibActionBar4:Hide();
				elseif (param == 5) then
					BibActionBar5:Hide();
				elseif (param == 6) then
					BibActionBar6:Hide();
				elseif (param == 7) then
					BibActionBar7:Hide();
				elseif (param == 8) then
					BibActionBar8:Hide();
				elseif (param == 9) then
					BibActionBar9:Hide();
				elseif (param == 10) then
					BibActionBar10:Hide();
				end
			else
				DEFAULT_CHAT_FRAME:AddMessage("Insomniax BibActionBar "..param.." is already being hidden.",225/255, 0, 175/255);
			end
		else
			DEFAULT_CHAT_FRAME:AddMessage("Invalid entry.  The action bar number must be between 1 and 10.",225/255, 0, 0);
		end
		
	elseif (strfind(msg, "showbar")) then
		local command, param = Asc_BibMod_CmdCapture(msg);
		
		param = tonumber(param);
		
		if ((param > 0) and (param <= BIB_ACTION_BAR_COUNT)) then
			if (not Asc_BibMod_Config.ShowBibBar[param]) then
				Asc_BibMod_Config.ShowBibBar[param] = true;
				DEFAULT_CHAT_FRAME:AddMessage("Insomniax BibActionBar "..param.." has been shown.",225/255, 0, 175/255);
				if (param == 1) then							
					BibActionBar1:Show();
				elseif (param == 2) then
					BibActionBar2:Show();
				elseif (param == 3) then
					BibActionBar3:Show();
				elseif (param == 4) then
					BibActionBar4:Show();
				elseif (param == 5) then
					BibActionBar5:Show();
				elseif (param == 6) then
					BibActionBar6:Show();
				elseif (param == 7) then
					BibActionBar7:Show();
				elseif (param == 8) then
					BibActionBar8:Show();
				elseif (param == 9) then
					BibActionBar9:Show();
				elseif (param == 10) then
					BibActionBar10:Show();
				end
			else
				DEFAULT_CHAT_FRAME:AddMessage("Insomniax BibActionBar "..param.." is already showing.",225/255, 0, 175/255);
			end
		else
			DEFAULT_CHAT_FRAME:AddMessage("Invalid entry.  The action bar number must be between 1 and 10.",225/255, 0, 0);
		end
	
	else
	
		Asc_BibModHelp();
		
	end

end

function Asc_BibModHelp()
	-- displays help info ingame
	
	DEFAULT_CHAT_FRAME:AddMessage("BibMod Help File",225/255, 0, 175/255);
	DEFAULT_CHAT_FRAME:AddMessage("\"/ixbib classbar\" will show/hide the Class Bar, such as the Druid Shapeshift bar, Warrior Stance Bar, etc.");
	DEFAULT_CHAT_FRAME:AddMessage("\"/ixbib color <default/red/green/blue/black>\" will change the Target Range color indicator to the color provided.");
	DEFAULT_CHAT_FRAME:AddMessage("\"/ixbib hidebar||showbar #\" will hide or show the action bar given by #. (Until I can fix this, if you hide a bar during this session you will have to show then hide it next session)");
	
end
