INSOMNIAX_BIBCORE_VERSION = 11200.02;


function GetHashedSaveValue(variableName, key)
	if(getglobal(variableName) == nil) then
		return nil;
	end
	return getglobal(variableName)[key];
end

function SetHashedSaveValue(variableName, key, value)
	local topLevelReference = getglobal(variableName);

	if(topLevelReference == nil) then
		setglobal(variableName, {});
		topLevelReference = getglobal(variableName);
	end

	topLevelReference[key] = value;
end

function AddBibControlButton(button)
	if(BibMenu.button_offset == nil) then
		BibMenu.button_offset = 0;
	end
	button:SetWidth(32);
	button:SetHeight(32);
	button:SetPoint("TOPLEFT", "BibMenuBar", "TOPLEFT", BibMenu.button_offset, 0);
	BibMenu.button_offset = BibMenu.button_offset + 29; -- was 32
	BibMenu:SetWidth(BibMenu.button_offset+16);
end

function UpdateBibMenuFoldState()
	if(BibMenuFolded) then
		BibMenuBar:Hide();
		BibMenu:SetWidth(16);
		BibMenuToggle:SetNormalTexture("Interface\\AddOns\\Insomniax_BibCore\\Images\\UnfoldBibMenu");
	else
		BibMenuBar:Show();
		BibMenu:SetWidth(BibMenu.button_offset+16);
		BibMenuToggle:SetNormalTexture("Interface\\AddOns\\Insomniax_BibCore\\Images\\FoldBibMenu");
	end
end

function BibShowPopupFrameAtCursor(frame)
	local X, Y = GetCursorPosition();

	leftEdge = X - frame:GetWidth();
	if(leftEdge < 0) then
		X = X - leftEdge;
	end

	topEdge = Y + frame:GetHeight();
	topOfScreen = GetScreenHeight() * UIParent:GetScale();
	if(topEdge > topOfScreen) then
		Y = Y - (topEdge - topOfScreen);
	end

	frame:SetPoint("BOTTOMRIGHT", "UIParent", "BOTTOMLEFT", X, Y);
	frame:Show()
end

function BibMenu_OnEnter()
	-- put the tool tip in the default position
	GameTooltip_SetDefaultAnchor(GameTooltip, this);

	if(BibMenuFolded) then
		GameTooltip:SetText("Insomniax BibCore Menu v"..INSOMNIAX_BIBCORE_VERSION.."", 255/255, 209/255, 0/255);
		GameTooltip:AddLine("Left-click to unfold the menu bar", 1.00, 1.00, 1.00);
		GameTooltip:AddLine("Using the BibMenu you can configure the", 80/255, 143/255, 148/255);
		GameTooltip:AddLine("BibToolbar mod and which of the original", 80/255, 143/255, 148/255);
		GameTooltip:AddLine("menu elements are displayed. Mouse over", 80/255, 143/255, 148/255);
		GameTooltip:AddLine("the different buttons to find out what", 80/255, 143/255, 148/255);
		GameTooltip:AddLine("each of them does.", 80/255, 143/255, 148/255);
		GameTooltip:Show();
	else
		GameTooltip:SetText("Insomniax BibCore Menu v"..INSOMNIAX_BIBCORE_VERSION.."", 255/255, 209/255, 0/255);
		GameTooltip:AddLine("Left-click to fold the menu bar", 1.00, 1.00, 1.00);
		GameTooltip:AddLine("Using the BibMenu you can configure the", 80/255, 143/255, 148/255);
		GameTooltip:AddLine("BibToolbar mod and which of the original", 80/255, 143/255, 148/255);
		GameTooltip:AddLine("menu elements are displayed. Mouse over", 80/255, 143/255, 148/255);
		GameTooltip:AddLine("the different buttons to find out what", 80/255, 143/255, 148/255);
		GameTooltip:AddLine("each of them does.", 80/255, 143/255, 148/255);
		GameTooltip:Show();
	end
end
