-- This function handles events for the XP bar we're using
-- to replace the one we removed in RemoveMainActionBar()
BibXPBarModeOFF = nil;
BibXPBarModeON = 1;
BibXPBarModeText =2;

function BibmodXPBarOnEvent (event)
	--***Asc_BibMod_OnEvent(event);

	if (event == "VARIABLES_LOADED") then	
		if (BibXPBarDisplayMode == BibXPBarModeText) then
			BibXPBarText:Show();
		else
			BibXPBarText:Hide();
		end
		return;		
	end

	if (event == "PLAYER_XP_UPDATE" or event == "PLAYER_LEVEL_UP" or event == "PLAYER_ENTERING_WORLD") then

		if (event == "PLAYER_ENTERING_WORLD") then
			if (BibXPBarDisplayMode == BibXPBarModeText) then
				BibXPBarText:Show();
			else
				BibXPBarText:Hide();
			end
		end

		local currXP = UnitXP("player");
		local nextlevelXP = UnitXPMax("player");
		local restXP = GetXPExhaustion();
		
		this:SetMinMaxValues(min(0, currXP), nextlevelXP);
		BibFatigueBar:SetMinMaxValues(min(0, currXP), nextlevelXP);
		this:SetValue(currXP);
		if(restXP == nil) then
			BibFatigueBar:SetValue(currXP);
		else
			BibFatigueBar:SetValue(currXP + (tonumber(restXP) / 2));
		end	
		UpdateBibXPBarText();
		return;
	end
end

function UpdateBibXPBarText()
		local currXP = UnitXP("player");
		local nextlevelXP = UnitXPMax("player");
		local restXP = GetXPExhaustion();
		
		local neededXP = nextlevelXP - currXP;
		local currlevel = UnitLevel("player");
		local nextlevel = (UnitLevel("player") + 1);
		local currXPpercent = ceil(currXP / nextlevelXP * 100);
		local neededXPpercent = 100 - currXPpercent;
		
		if(restXP == nil) then
			BibXPBarText:SetText(currXP.." ("..currXPpercent.."%) / "..nextlevelXP.."xp | "..neededXPpercent.."% ("..neededXP.."xp) to level "..nextlevel);
		else
			BibXPBarText:SetText(currXP.." ("..currXPpercent.."%) / "..nextlevelXP.."xp | "..neededXPpercent.."% ("..neededXP.."xp) to level "..nextlevel.." | "..(tonumber(restXP) / 2).." xp bonus");
		end
end

function BibXPBar_OnMouseDown(arg1)
	if ( (arg1 == "LeftButton") and (not BibActionBarButtonsLocked) ) then
		BibmodXPFrame:StartMoving()
	end
end

function BibXPBar_OnMouseUp(arg1)
	if (arg1 == "LeftButton") then
		BibmodXPFrame:StopMovingOrSizing()
	end
end

function BibXPBar_OnEnter()

	-- Ascendant 07-01-05 : added switch to control how text displays based on whether or not the use wants the text displayed all the time
	if (BibXPBarDisplayMode == BibXPBarModeON) then	
		BibXPBarText:Show();		
	end
	-- end of Asc's addition
	
	-- put the tool tip in the default position
	GameTooltip_SetDefaultAnchor(GameTooltip, this);
	
	-- set the tool tip text
	GameTooltip:SetText("Insomniax BibToolbars XP Bar", 255/255, 209/255, 0/255);
	GameTooltip:AddLine("Left-click to move", 1.00, 1.00, 1.00);
	GameTooltip:AddLine("This experience bar is divided into twenty", 80/255, 143/255, 148/255);
	GameTooltip:AddLine("segments each representing five percent of", 80/255, 143/255, 148/255);
	GameTooltip:AddLine("the total experience needed to reach the next", 80/255, 143/255, 148/255);
	GameTooltip:AddLine("level. To move the experience bar make sure", 80/255, 143/255, 148/255);
	GameTooltip:AddLine("that the action buttons are unlocked on the", 80/255, 143/255, 148/255);
	GameTooltip:AddLine("bibmod control panel; to always show the text", 80/255, 143/255, 148/255);
	GameTooltip:AddLine("or to hide it, click on the XP control button.", 80/255, 143/255, 148/255);	
	GameTooltip:Show();
end

-- Ascendant 07-01-05 : added 'OnLeave' event to handle switch to control how text displays based on whether or not the user wants the text diplayed all the time
function BibXPBar_OnLeave()

	if (BibXPBarDisplayMode == BibXPBarModeON) then	
		BibXPBarText:Hide();				
	end	
	GameTooltip:Hide();
	
end
